Attribute VB_Name = "StartUp"
Option Explicit

Private Chat            As String * 7520
Private EnterMsg        As String
Private ChatMsg         As String
Private LastChatMsg     As String
Private NameLen         As Integer 'NameLen = Peek2(4569164)
Private hTickedWindow   As Long
Private StartMsg        As Long
Private WindowRgn       As RECT

Private Prefix          As String
Private Plaintext       As String
Private Ciphertext      As String

Private CommandChar     As String

Private Password        As Long

Private Enabled         As Boolean

Public Sub Main()

    CommandChar = "%"
    Password = MakeKey("PuBlIc")
    Enabled = True

    If RunProcess("subspace.bin") = False Then
        If RunProcess("subspace.exe") = False Then
            MsgBox "Sheepo could not find SubSpace", vbCritical, "Sheep-related Error Report"
            UnloadHandles
            End
        End If
    End If

    Do
        DoEvents

        ChatMsg = TrimZero(Peek160(4738624))

        StartMsg = InStr(3, ChatMsg, Chr(174) + Chr(168))

        If StartMsg > 0 Then
            If LastChatMsg = ChatMsg Then GoTo NextLoop
            LastChatMsg = ChatMsg

            Plaintext = Cipher(Unpack(Mid(ChatMsg, StartMsg + 2)), Password)

            If CheckChecksum(Plaintext) = True Then AddMsg String(StartMsg - 1, " ") + Plaintext, 5
        Else
            EnterMsg = TrimZero(Peek220(4814872))

            If Left(EnterMsg, 1) = CommandChar Then
                If Mid(EnterMsg, 2) = "help" Then
                    SetEnterText ""
                    If Enabled = True Then
                        AddMsg "(Sheepo:ENABLED)     - Commands:", 7
                        AddMsg CommandChar + "disable             - Disable Sheepo", 7
                    Else
                        AddMsg "(Sheepo:DISABLED)    - Commands:", 7
                        AddMsg CommandChar + "enable              - Enable Sheepo", 7
                    End If
                        AddMsg CommandChar + "key <new key>       - Assign a new Command Prefix (Currently '" + CommandChar + "')", 7
                        AddMsg CommandChar + "pass <new password> - Use a different password for Ciphering (6 characters)", 7
                        AddMsg "<message> " + CommandChar + "          - Cipher a message", 7
                ElseIf Mid(EnterMsg, 2) = "enable" Then
                    SetEnterText ""
                    AddMsg "(Sheepo:ENABLED)", 7
                    Enabled = True
                ElseIf Mid(EnterMsg, 2) = "disable" Then
                    SetEnterText ""
                    AddMsg "(Sheepo:DISABLED)", 7
                    Enabled = False
                ElseIf Mid(EnterMsg, 2, 4) = "key " And Len(EnterMsg) > 5 Then
                    SetEnterText ""
                    CommandChar = Mid(EnterMsg, 6, 1)
                    If CommandChar = "" Then CommandChar = "%"
                    AddMsg "New Sheepo Command Prefix : " + CommandChar + " [Type """ + CommandChar + "help"" for new commands]", 7
                ElseIf Mid(EnterMsg, 2, 5) = "pass " And Len(EnterMsg) > 11 Then
                    SetEnterText ""
                    Password = MakeKey(Mid(EnterMsg, 7, 6))
                    AddMsg "Password has been changed : " + Mid(EnterMsg, 7, 6) + " [Sheepo users with this password may now communicate with you]", 7
                End If
            ElseIf (Right(EnterMsg, 1) = CommandChar) Then
                If Enabled = True Then
                    Plaintext = Left(EnterMsg, Len(EnterMsg) - 1)
                    '<team msg // or '>
                    If Left(Plaintext, 2) = "//" Then
                        Ciphertext = "//" + Chr(174) + Chr(168) + Pack(Cipher(AttachChecksum(Mid(Plaintext, 3)), Password))
                    ElseIf Left(Plaintext, 1) = "'" Then
                        Ciphertext = "'" + Chr(174) + Chr(168) + Pack(Cipher(AttachChecksum(Mid(Plaintext, 2)), Password))
                    '<local private>
                    ElseIf Left(Plaintext, 1) = "/" Then
                        Ciphertext = "/" + Chr(174) + Chr(168) + Pack(Cipher(AttachChecksum(Mid(Plaintext, 2)), Password))
                    '<remote private>
                    ElseIf Left(Plaintext, 1) = ":" Then
                        StartMsg = InStr(3, Plaintext, ":")
                        If StartMsg > 0 Then
                            Ciphertext = Left(Plaintext, StartMsg) + Chr(174) + Chr(168) + Pack(Cipher(AttachChecksum(Mid(Plaintext, StartMsg + 1)), Password))
                        End If
                    '<?chat msg>
                    ElseIf Left(Plaintext, 1) = ";" Then
                        StartMsg = InStr(3, Plaintext, ";")
                        If StartMsg = 3 Then
                            Ciphertext = Left(Plaintext, StartMsg) + Chr(174) + Chr(168) + Pack(Cipher(AttachChecksum(Mid(Plaintext, StartMsg + 1)), Password))
                        Else
                            Ciphertext = ";" + Chr(174) + Chr(168) + Pack(Cipher(AttachChecksum(Mid(Plaintext, 2)), Password))
                        End If
                    '<team private message>
                    ElseIf Left(Plaintext, 1) = """" Then
                        Ciphertext = """" + Chr(174) + Chr(168) + Pack(Cipher(AttachChecksum(Mid(Plaintext, 2)), Password))
                    '<public msg>
                    Else
                        Ciphertext = Chr(174) + Chr(168) + Pack(Cipher(AttachChecksum(Plaintext), Password))
                    End If
                    '* = ignore
                    If Left(Plaintext, 1) <> "*" Then SetEnterText Ciphertext
                End If
            End If
        End If

NextLoop:
    Loop While Err.LastDllError = 0       'Loop while the Read/WriteProcessMemory() API's are functioning properly.

    UnloadHandles
    End
End Sub

Public Sub AddMsg(mStr As String, Color As Byte)
    Chat = Peek7520(4738597)

    Chat = String(23, 0) + Chr(&H3F) + String(3, 0) + FillZero(mStr, 160) + Chr(Color) + Left(Chat, 7520 - 188)

    PokeS 4738597, Chat
End Sub

Public Sub SetEnterText(mStr As String)
    Call PokeS(4814872, mStr + Chr(0))

    hTickedWindow = Peek4(4923828)
    If hTickedWindow <> 0 Then SendMessage GetWindow(hTickedWindow, 5), &HC, 0, ByVal mStr
End Sub
